import graph.Node;
import graph.NodePair;
import graph.TwoNodes;

import java.util.HashMap;
import java.util.Iterator;
import java.util.TreeSet;


public class MyHeap
{
	public TreeSet<NodePair> heap;
	public HashMap<TwoNodes, Double> heapAux;
    public static double verySmallDouble = .01;

	public MyHeap()
	{
		heap = new TreeSet<NodePair>();
		heapAux = new HashMap<TwoNodes, Double>();
	}

	public NodePair getTop()
	{
            NodePair np = heap.last();
            heap.remove(np);
            heapAux.remove(new TwoNodes(np.id1, np.id2));
            return np;
	}

	public void clear()
	{
		heap.clear();
                heapAux.clear();
	}

	public int insert(NodePair p, double threshold)
	{
		//if (p.cost > threshold) // FASTER TIME!
		if (p.cost > threshold) // SMALLER SUMMARY!
		{
//                     System.out.println("adding " + p.id1 + " " + p.id2);
			heap.add(p);
			heapAux.put(new TwoNodes(p.id1,p.id2),p.cost);
			return 1;
		}

		return 0;
	}

	public int insertCheck(NodePair p, double threshold)
	{
            TwoNodes _tp =  new TwoNodes(p.id1,p.id2);
            if(heapAux.containsKey(_tp)){
                double cost = heapAux.get(_tp);
                if(Math.abs(p.cost - cost) < verySmallDouble){
                    // same pair being re-insert, do nothing
                    return 0;
                }
                NodePair p2 = new NodePair(p.id1, p.id2, cost);
                heap.remove(p2);
                if (p.cost < threshold){
                    heapAux.remove(_tp);
                    return 0;
                }
            }
            if (p.cost < threshold){
                return 0;
            }

            heap.add(p);
            heapAux.put(_tp,p.cost);
            return 1;
	}

	// Other option is to double the memory.
	public void removeInstancesOf(Node a)
	{
            NodePair np;

            // Linear search through the heap to find all pairs with Node a.
            for (Iterator i = heap.iterator(); i.hasNext(); ){
                np = (NodePair) i.next();
                if (np.id1 == a.id || np.id2 == a.id)
                    i.remove();
            }
	}

	public void printHeap()
	{
		for (NodePair np : heap)
		{
			System.out.println(np.id1 + " " + np.id2 + " " + np.cost);
		}
	}

	public void add2Hop(Node c)
	{

	}
}
